﻿Type=Class
Version=2.51
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
#Event: PageChanged (Position As Int)
#DesignerProperty: Key: BackgroundColor, DisplayName: Background Color, FieldType: Color, DefaultValue: #FFFFFFFF
Sub Class_Globals
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private mBase As WeakRef
	Private sv As ScrollView
	Private panels As List
	Private EventName As String
	Private CallBack As Object
	Public BackgroundColor As Int
	Public PagingEnabled As Boolean
	Public CurrentPage As Int
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
	panels.Initialize
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase.Value = Base
	sv.Initialize("sv", Base.Width, Base.height)
	Base.AddView(sv, 0, 0, Base.Width, Base.Height)
	Base.Color = Props.Get("BackgroundColor")
	sv.PagingEnabled = True
	sv.ShowsHorizontalIndicator = True
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	sv.ContentHeight = Height
	sv.ContentWidth = Width * panels.Size
	For i = 0 To panels.Size - 1
		Dim p As Panel = panels.Get(i)
		p.SetLayoutAnimated(0, 1, i * Width, 0, Width, Height)
	Next
End Sub

Public Sub GetBase As Panel 
	Return mBase.Value
End Sub

'Clears all items.
Public Sub Clear
	panels.Clear
	sv.ContentHeight = 0
	sv.Panel.RemoveAllViews
End Sub

'Returns the number of items.
Public Sub GetSize As Int
	Return panels.Size
End Sub

' return the underlying panel at a particular index
public Sub GetPageObject(Index As Int) As Panel
	Dim p As Panel
	p = panels.Get(Index) 'this is the parent panel
	Return p.GetView(0)
End Sub

' add a panel page to the scrollview
Public Sub AddPage(pnl As Panel)
	Dim p As Panel
	p.Initialize("p")
	p.Tag = panels.size
	p.AddView(pnl, 0, 0, 100%x, 100%y)
	panels.Add(p)
	sv.Panel.AddView(p, 0, 0, 0, 0)
End Sub

' when the scroll is changd, fire, pageChanged event
Sub sv_ScrollChanged (OffsetX As Int, OffsetY As Int)
	For Each p As Panel In panels
		If p.Left = OffsetX Then
			CurrentPage = p.tag
			CallSub2(CallBack, EventName & "_PageChanged", p.Tag)
		End If
	Next
End Sub

' go to a particular page of the scroll
public Sub GotoPage(Index As Int, bSmooth As Boolean)
	CurrentPage = Index
	sv.ScrollTo((Index) * sv.Panel.Width, 0, bSmooth)
End Sub